/*------- Variables globales ------*/
var rueda_g; // :Rueda. La rueda que vamos a crear
var propietario_g; // :Profesor. El dueño del dispositivo.
var numPropietario_g = "";
var conductores_g; // Conductores de cada dia de todo el curso
var paginaAnterior = "";
var vista_g;
var botonNavegacion_g;
var semanaRenderizada; // La semana que tenemos renderizada


/* Nos movemos a la vista diaria del dia de hoy
 */
function irAHoy() {

    var hoy = (new Date).getDay() - 1;
    hoy = hoy < 0 ? 6 : hoy; // Quitar el valor negativo para el domingo
    $(":mobile-pagecontainer").pagecontainer("change", '#' + Rueda.DIA_NOMBRES[hoy]);

}

var dispositivoListo = $.Deferred();

document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {

    // Identificaremos los profesores por su dipositivo
    numPropietario_g = device.uuid;

    // Quitar las transiciones 
    $.extend($.mobile, {
        defaultPageTransition: 'none'
    });

    /* Desactivar el botón de vuelta del dispositivo, cuando volvemos desde ciertas paginas
    $(":mobile-pagecontainer").pagecontainer({


        beforechange: function(event, ui) {
            var noVolver = [
                ['#registro', '#index'],
                ['#crearUnir', '#confirmacionRegistro']
            ];
            var desde = $.mobile.activePage.attr('id');
            var hacia = ui.toPage;

            for (i = 0; i < noVolver.length && !fin; i++) {
                if (desde === noVolver[i][0] && hacia === noVolver[i][1]) {
                    e.preventDefault();
                    fin = true;
                }
            }
        }
    });
*/
    dispositivoListo.resolve();

}

/*------------ INDEX PAGE ------------------------------------------------*/
$(document).one("pagebeforecreate", "#index", function(event, ui) {
    // Cargamos el panel lateral
    $.get("panel.html", function(data) {
        $.mobile.pageContainer.append(data);
        $("[data-role=panel]").panel().enhanceWithin();
    }, "html");

    $("#headerInicio").toolbar({ theme: "a" });


    $("#mypanel_btn").on("click", function() {
        $("[data-role=panel]").panel("open");
    });

    $("#registro_btn").on("click", function() {
        $(":mobile-pagecontainer").pagecontainer("change", "#registro");
    });

    $("#hoy_btn").on("click", function() {
        renderRueda(Rueda.semanaEnCurso());
        irAHoy();
    });
    $("#semana_btn").on("click", function() {
        renderRueda(Rueda.semanaEnCurso());
        $(":mobile-pagecontainer").pagecontainer("change", "#semana_page");
    });
    $("#anual_btn").on("click", function() {
        renderRueda(Rueda.semanaEnCurso());
        $(":mobile-pagecontainer").pagecontainer("change", "#anual_page");
    });
    // Establecemos los listeners para los desplazamientos de pagina
    $(document).on("swipeleft", ".ui-page", function(event) {
        if ($.mobile.activePage.attr('id') == "semana_page") {
            if (semanaRenderizada == 42) {
                navigator.notification.alert(
                    'Esta es la ultima semana del curso', // message
                    function() {; },
                    'Siguiente', // title
                    'OK' // buttonName
                );

            } else {
                renderRueda(++semanaRenderizada);
                $(":mobile-pagecontainer").pagecontainer("change", "#semana_page", { transition: "slide", allowSamePageTransition: true });
            }
        } else {
            var next = $(this).jqmData("next");
            if (next && (event.target === $(this)[0])) {
                $.mobile.changePage('#' + next, { transition: "slide" });
            }
        }
    });

    $(document).on("swiperight", ".ui-page", function(event) {
        if ($.mobile.activePage.attr('id') == "semana_page") {

            if (semanaRenderizada == 0) {
                navigator.notification.alert(
                    'Esta es la primera semana', // message
                    function() {; },
                    'Anterior', // title
                    'OK' // buttonName
                );

            } else {
                renderRueda(--semanaRenderizada);
                $(":mobile-pagecontainer").pagecontainer("change", "#semana_page", { transition: "slide", reverse: true, allowSamePageTransition: true });
            }
        } else {
            var prev = $(this).jqmData("prev");
            if (prev && (event.target === $(this)[0])) {
                $.mobile.changePage('#' + prev, { transition: "slide", reverse: true });
            }
        }

    });


});

$(document).on("pagebeforeshow", "#index", function(event, ui) {

    $("#headerInicio").hide();
    localforage.getItem('botonNavegacion').then(
        function(response) {
            botonNavegacion_g = (response == null) ? false : response;
        });


    $.when(dispositivoListo).then(function() {

        Profesor.recuperaProfesor(numPropietario_g).then(function(response) {
            propietario_g = response;

            if (propietario_g == null) { // Si el usuario no se ha registrado todavia lo registramos

                if (navigator.connection.type === Connection.NONE) {

                    navigator.notification.confirm(
                        'Es necesario conexión a Internet para registrarse. Activa la conexión y presiona OK',
                        function(button) {
                            if (button == 1) {
                                $(":mobile-pagecontainer").pagecontainer("change", "#index", { allowSamePageTransition: true });
                            }
                        },
                        'Conexión',
                        'OK'
                    );

                } else {

                    Profesor.recuperaServer(numPropietario_g).then(

                        function(response) {
                            if (response != null) { // Este dispositivo ya estaba registrado y se ha vuelto a instalar la app
                                propietario_g = response;
                                propietario_g.almacenarLocal();
                                console.log("pro" + JSON.stringify(propietario_g));

                                Rueda.recuperaRuedaServer(propietario_g.getRueda()).then(
                                    function(response) {

                                        rueda_g = response;
                                        rueda_g.setPropietario(propietario_g);
                                        rueda_g.almacenar();

                                        navigator.notification.confirm(
                                            propietario_g.getNombre() + ' ya estabas registrado en: ' + rueda_g.getTitulo(), // message
                                            function(button) {
                                                if (button == 1) {
                                                    $(":mobile-pagecontainer").pagecontainer("change", "#index", { allowSamePageTransition: true });
                                                }
                                            },
                                            'Registro', // title
                                            'OK' // buttonName
                                        );
                                    });

                            } else {
                                $("#registro_btn").css("visibility", "visible");
                                $("#hoy_btn").css("visibility", "hidden");
                                $("#semana_btn").css("visibility", "hidden");
                                $("#anual_btn").css("visibility", "hidden");
                            }
                        }
                    );
                }
            } else {

                Rueda.recuperaRueda().then(function(response) {
                    rueda_g = response;

                    if (rueda_g == null) { // Si la rueda no existe la construimos o nos unimos

                        $(":mobile-pagecontainer").pagecontainer("change", "#crearUnir");

                    } else {
                        localforage.getItem('vista').then(
                            function(response) {
                                vista_g = (response == null) ? "home" : response;
                                switch (vista_g) {
                                    case "home":
                                        $("#registro_btn").css("visibility", "hidden");
                                        $("#hoy_btn").css("visibility", "visible");
                                        $("#semana_btn").css("visibility", "visible");
                                        $("#anual_btn").css("visibility", "visible");
                                        break;
                                    case "diaria":
                                        renderRueda(Rueda.semanaEnCurso());
                                        irAHoy();
                                        break;
                                    case "semanal":
                                        renderRueda(Rueda.semanaEnCurso());
                                        $(":mobile-pagecontainer").pagecontainer("change", "#semana_page");
                                        break;
                                }
                            }
                        );

                    }
                });
            }
        });

    });

});

/*--------- REGISTRO PAGE -------------------------------------------------*/
$(document).on("pagebeforeshow", "#registro", function(event, ui) {
    $("#headerInicio").show();
});

$(document).one("pagebeforecreate", "#registro", function(event, ui) {

    $("#headerInicio #titulo").html("Nuevo usuario");

    // Creamos los sliders de seleccion
    $("#selHoras").append(
        Handlebars.templates.selHoras(["Lunes", "Martes", "Miercoles", "Jueves", "Viernes"])
    );

    /* El botón guarda recoge los datos introducidos por el usuario y crea un objeto profesor
     * para almacenarlos. Una vez guardados se lanza la pagina de confirmación.
     */
    $("#guardar").on("click", function() {

        if ($("#nombre").val().length == 0) {
            navigator.notification.alert(
                'El nombre no puede quedar vacio', // message
                function() {},
                'Error', // title
                'OK' // buttonName
            );

        } else {

            propietario_g = new Profesor($("#nombre").val(), numPropietario_g, $("#Lunes_e").val(), $("#Lunes_s").val(),
                $("#Martes_e").val(), $("#Martes_s").val(), $("#Miercoles_e").val(), $("#Miercoles_s").val(), $("#Jueves_e").val(),
                $("#Jueves_s").val(), $("#Viernes_e").val(), $("#Viernes_s").val()
            );

            $(":mobile-pagecontainer").pagecontainer("change", '#confirmacionRegistro');
        }
    });

});

/*--------- CONFIRMACION REGISTRO PAGE -------------------------------------------------*/
/* Muestra un feedback de los datos introducidos por el usuario.
 */
$(document).one("pagebeforeshow", "#confirmacionRegistro", function(event, ui) {

    $("#headerInicio #titulo").html("Tu horario");

    // Mostrar el nombre registrado
    $("#nombreRegistrado").html("<p>" + propietario_g.getNombre() + "</p><p>vas a registrar este horario</p>");

    $("#horario").html(
        Handlebars.templates.cabeceraRegistro([
            ['a', 'L'],
            ['b', 'M'],
            ['c', 'X'],
            ['d', 'J'],
            ['e', 'V']
        ]) +
        Handlebars.templates.horario([1, 2, 3, 4, 5, 6])
    );

    // Mostrar el horario registrado
    for (dia = 0; dia < 5; dia++) {

        var inicio = parseInt(propietario_g.getEntrada(dia));
        var fin = parseInt(propietario_g.getSalida(dia));

        for (hora = 1; hora < 7; hora++) {
            if (inicio > hora || fin < hora || inicio == fin) {
                $("#" + Rueda.DIA_LETRAS[dia] + "-" + hora).css("background", "#444444");
            } else {
                $("#" + Rueda.DIA_LETRAS[dia] + "-" + hora).css("background", "#ffffff");
            }
        }
    }

    $("#alaRueda_btn").on("click", function() {

        if (propietario_g.getIDBD() == -1) {
            if (navigator.connection.type === Connection.NONE) {
                alert("Debes tener conexión a Internet");
            } else {
                propietario_g.almacenarServer();
                // Si estamos modificando el perfil debemos cambiar también la rueda
                $(":mobile-pagecontainer").pagecontainer("change", '#crearUnir');
            }
        } else {
            navigator.notification.alert(
                'Ya estabas registrado', // message
                function() {},
                'Registro', // title
                'OK' // buttonName
            );
            $(":mobile-pagecontainer").pagecontainer("change", '#crearUnir');
        }
    });

});



function renderRueda(sem) {
    semanaRenderizada = sem;

    //--- renderizado de la cabecera
    var lunes = Rueda.lunesSemana(sem);
    var domingo = Rueda.domingoSemana(sem);
    var mes = domingo.getMonth() + 1;
    var anio = domingo.getFullYear();

    $("#headerInicio h1#titulo").html(
        'Semana: <span class="fechaSemana">' + lunes.getDate() + ' - ' + domingo.getDate() + '/' + mes + '/' + anio + '<span>'
    );

    // Integrantes de las rueda semanal
    var semana = rueda_g.generarRuedaSemana();

    // Conductores de esta semana
    var conductoresSem = rueda_g.conductoresSemana(sem, rueda_g.conductoresCurso());

    for (var dia = 0; dia < 5; dia++) {
        var HTML = '<ul  style="padding-left: 1em" class="listaCoincidencias">'
        var cantidadProfes = semana[dia].length;

        // Insertar los profesores del dia en curso
        for (var i = 0; i < cantidadProfes; i++) {
            var profe = semana[dia][i];

            // Ponemos un cochecito al lado del profesor que le toca conducir
            // Si hay mas de 5 profesores ese dia necesitamos un coche mas y conduce el que este 5 puestos
            // mas delante en la lista de este dia
            if (profe.getUUID() == conductoresSem[dia]) {
                HTML += '<li class="resaltarCoincidencias"';

            } else {
                if (cantidadProfes > 5) {

                    for (var posConductor = 0; semana[dia][posConductor].getUUID() != conductoresSem[dia]; posConductor++);

                    var otroConductor = semana[dia][(posConductor + cantidadProfes / 2) % cantidadProfes];
                    if (profe.getUUID() == otroConductor.getUUID()) {
                        HTML += '<li class="resaltarCoincidencias"';
                    } else {
                        HTML += '<li';
                    }
                } else {
                    HTML += '<li';
                }
            }
            HTML += ' id="' + profe.getUUID() + '">';
            HTML += profe.getNombre();
            HTML += '</li>';
        }
        HTML += '</ul>';

        // Conductores de cada dia en la vista diaria
        $("div#" + Rueda.DIA_NOMBRES[dia] + " div div.lista").html(HTML);

        // Conductores de cada dia en la vista semanal
        $("div#sem" + Rueda.DIA_NOMBRES[dia]).html(HTML);

    }
}

/*--------- CREAR O UNIRSE A UNA RUEDA -------------------------------------------------*/
/* Muestra la lista de acciones sobre la rueda
 */
$(document).on("pagebeforeshow", "#crearUnir", function(event, ui) {

    $("#headerInicio").show();
    $("#headerInicio #titulo").html("Unirse a una rueda");

    var tituloRueda = "todavia ninguna";
    if (rueda_g != null) tituloRueda = rueda_g.getTitulo();

    $("#nombreRueda_t").html("<p>" + propietario_g.getNombre() + " estas en la rueda: </p><p> <b>" + tituloRueda + "</b></p>");

    // Boton para agregar contactos. Hace uso del plugin cordova-plugin-contacts
    $("#contacto").on("click", function() {

        navigator.contacts.pickContact(function(contact) {

            // FIREBASE CLOUD MESSAGE !!

            /* Quitamos los espacios en blanco y el +34 si existe. Recordemos que hablamos de profesor de España*/
            var telefono = (contact.phoneNumbers[0].value).replace(/\s/g, '').replace('+34', '');

            /* Esta parte se cambia por una invitación al nuevo miembro mediante notificación PUSH
             * Para la versión actual suponemos que el usuario ha aceptado implicitamente
             **
            Profesor.recuperaProfesorServer(telefono).then(
                function(response) {
                    rueda_g.addMiembro(response); // response es un profesor
                },
                function(error) {
                    console.error("Fallo: ", error);
                }
            );*/

            if (!$('#' + telefono).length) {

                $("#listaContactos").append('<li id="' + telefono + '">' + contact.displayName + '</li>');
                $("#listaContactos").listview("refresh");
            }

        }, function(err) {
            console.log('Error: ' + err);
        });
    });

    $("#crearRueda_btn").on("click", function() {

        if (navigator.connection.type === Connection.NONE) {

            alert("Debes tener conexión a Internet");

        } else {

            Rueda.existe($("#tituloRueda").val()).then(
                function(response) {
                    if (!response) {
                        propietario_g.setRueda($("#tituloRueda").val());
                        propietario_g.actualizaServer();

                        rueda_g = new Rueda(propietario_g, $("#tituloRueda").val());
                        rueda_g.addMiembro(propietario_g);
                        rueda_g.setPropietario(propietario_g);
                        rueda_g.almacenar();

                        $(":mobile-pagecontainer").pagecontainer("change", '#index');
                    } else {
                        navigator.notification.alert(
                            'Ya existe una rueda con ese nombre', // message
                            function() {},
                            'Error', // title
                            'OK' // buttonName
                        );

                    }
                }
            );
        }
    });

    // Unirse a una rueda
    $("#ruedaBusqueda_btn").on("click", function() {

        if (navigator.connection.type === Connection.NONE) {

            alert("Debes tener conexión a Internet");

        } else {

            if (rueda_g == null || $("#ruedaBusqueda_inp").val() != rueda_g.getTitulo()) {

                Rueda.recuperaRuedaServer($("#ruedaBusqueda_inp").val()).then(
                    function(response) {
                        if (response.esVacia()) {
                            navigator.notification.alert(
                                'Esa rueda no existe', // message
                                function() {},
                                'Error', // title
                                'OK' // buttonName
                            );

                        } else {
                            rueda_g = response;
                            propietario_g.setRueda($("#ruedaBusqueda_inp").val());
                            rueda_g.addMiembro(propietario_g);
                            rueda_g.setTitulo($("#ruedaBusqueda_inp").val());
                            rueda_g.setPropietario(propietario_g);
                            rueda_g.almacenar();
                            propietario_g.actualizaServer();

                            $(":mobile-pagecontainer").pagecontainer("change", '#index');
                        }
                    },
                    function(error) {
                        console.error("Fallo: ", error);
                    }
                );
            } else {

                navigator.notification.alert(
                    'Ya estabas en esa rueda', // message
                    function() {},
                    'Sin cambios', // title
                    'OK' // buttonName
                );

            }
        }
    });


});


/*--------------- DIAS PAGE ----------------------------------------------*/
/* Carga la cabecera, el menu lateral y los eventos de desplazamiento que se disparan al deslizar
 * la pantalla. Además, generamos la rueda diaria.
 *
$(document).one("pagebeforecreate", ".dia", function() {

    // Obtener la fecha del lunes de esta semana
    var dia = new Date();
    var day = dia.getDay();
    dia.setDate(dia.getDate() - day + (day == 0 ? -6 : 1) + (Rueda.DIA_NOMBRES.indexOf($.mobile.activePage.attr('id'))));
    var mes = dia.getMonth() + 1;
    var anio = dia.getFullYear();

    $("#headerInicio").show();
    $("#headerInicio h1#titulo").html(
        $.mobile.activePage.attr('id') + ': <span class="fechaSemana">' +
        dia.getDate() + '/' + mes + '/' + anio + '<span>'
    );

});
*/
$(document).on("pagebeforeshow", ".dia", function() {
    if (botonNavegacion_g) $(".boton_navegacion").show();
    else $(".boton_navegacion").hide();

    // Obtener la fecha del lunes de esta semana
    var dia = new Date();
    var day = dia.getDay();
    dia.setDate(dia.getDate() - day + (day == 0 ? -6 : 1) + (Rueda.DIA_NOMBRES.indexOf($.mobile.activePage.attr('id'))));
    var mes = dia.getMonth() + 1;
    var anio = dia.getFullYear();

    $("#headerInicio").show();
    $("#headerInicio h1#titulo").html(
        $.mobile.activePage.attr('id') + ': <span class="fechaSemana">' +
        dia.getDate() + '/' + mes + '/' + anio + '<span><br>'
    );

});



$(document).on("pagebeforeshow", "#semana_page", function() {
    $("#headerInicio").show();
    if (botonNavegacion_g) $(".boton_navegacion").show();
    else $(".boton_navegacion").hide();
});

$(document).one("pagebeforecreate", "#semana_page", function() {

    $("#semDer_btn").on("click", function() {
        if (semanaRenderizada == 42) {
            navigator.notification.alert(
                'Esta es la ultima semana del curso', // message
                function() {; },
                'Siguiente', // title
                'OK' // buttonName
            );

        } else {
            renderRueda(++semanaRenderizada);
        }
    });

    $("#semIzq_btn").on("click", function() {
        if (semanaRenderizada == 0) {
            navigator.notification.alert(
                'Esta es la primera semana', // message
                function() {; },
                'Anterior', // title
                'OK' // buttonName
            );

        } else {

            renderRueda(--semanaRenderizada);
        }
    });
});

function renderRuedaASem(sem) {

    renderRueda(sem);
    $(":mobile-pagecontainer").pagecontainer("change", "#semana_page");

}

$(document).on("pagebeforeshow", "#anual_page", function() {
    var hoy = new Date();
    var curso = hoy.getMonth() > 8 ? hoy.getFullYear() : hoy.getFullYear() - 1;

    $("#headerInicio").show();
    $("#headerInicio h1#titulo").html(
        'Curso: <span class="fechaSemana">' + curso + ' / ' + (curso + 1) + '</span>'
    );

    var meses = ['Septiembre', 'Octubre', 'Noviembre', 'Diciembre', 'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio'];
    var bloques = ['a', 'b', 'c', 'd', 'e'];
    var mes = 0; // Indica el mes en el que estamos
    var dia = Rueda.primerLunesSeptiembre();
    var contDias = 0; // Cuenta los dias de todo el curos uno por uno
    var HTML = ''; // Contendrá todo el HTML de salida
    var temp = new Date(); // Temporal para ir calculando los dias según el calendario
    var UUIDpropietario = propietario_g.getUUID();
    var semanaEnCurso = Rueda.semanaEnCurso();

    // Conductores de cada dia
    conductores_g = rueda_g.conductoresCurso();

    var cantidConducciones = 0;
    for (var i = 0; i < conductores_g.length; i++) {
        if (conductores_g[i] == UUIDpropietario)
            cantidConducciones++;
    }

    HTML += '<span style="font: 1em Arial">Haces ' + cantidConducciones + ' viajes</span>';

    for (var i = 0; i < 43; i++) { // Tenemos 43 semanas
        // Si es la primera semana, primero ponemos la cabecera del mes
        if (dia.getDate() < 8) {

            HTML += '<div class="ui-grid-a tituloMes" id=mes_"' + mes + '">';
            HTML += '<div class="ui-block-a" id="' + meses[mes] + '">' + meses[mes] + '</div>';
            HTML += '</div>';
            mes++;
        }

        // Escribimos los dias de la semana
        lunes = dia.getDate();
        var dom = new Date();
        dom.setDate(dia.getDate() + 6);
        domingo = dom.getDate();

        if (i == semanaEnCurso)
            HTML += '<div style="color:#aa0d13;border:0.1em solid #aa0d13" class="ui-grid-d diasMes" id="sem_' + i + '" onclick="renderRuedaASem(' + i + ',' + lunes + ',' + domingo + ',' + (dia.getMonth() + 1) + ',' + dia.getFullYear() + ')">';
        else
            HTML += '<div class="ui-grid-d diasMes" id="sem_' + i + '" onclick="renderRuedaASem(' + i + ' )">';

        for (var j = 0; j < 5; j++) {
            temp.setDate(dia.getDate() + j);
            HTML += '<div class="ui-block-' + bloques[j] + '" id="' + i + j + '" style="text-align:center">';
            HTML += temp.getDate();
            if (conductores_g[contDias] == UUIDpropietario) HTML += '<br><img src="img/cochecito.png">';
            HTML += '</div>';

            contDias++;
        }
        HTML += '</div>';

        dia.setDate(dia.getDate() + 7); // Saltamos a la siguiente semana
    }
    $("#cuerpoAnual").html(HTML);

});


$(document).on("pagebeforecreate", "#contacto_page", function() {

    $("#headerInicio h1#titulo").html('Sobre RuedaCoches');

});

$(document).one("panelbeforeopen", "#mypanel", function() {

    $("#datosRueda_btn").on("click", function() {
        $("[data-role=panel]").panel("close");
        $(":mobile-pagecontainer").pagecontainer("change", "#datosRueda_page");
    });

    $("#panelDiario_btn").on("click", function() {

        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Vista diaria', // title
                'OK' // buttonName
            );
        } else {
            $("[data-role=panel]").panel("close");
            renderRueda(Rueda.semanaEnCurso());
            irAHoy();
        }

    });

    $("#vista_semana_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Vista semanal', // title
                'OK' // buttonName
            );
        } else {
            $("[data-role=panel]").panel("close");
            renderRueda(Rueda.semanaEnCurso());
            $(":mobile-pagecontainer").pagecontainer("change", "#semana_page");
        }
    });

    $("#vista_anual_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Vista anual', // title
                'OK' // buttonName
            );
        } else {
            $("[data-role=panel]").panel("close");
            $(":mobile-pagecontainer").pagecontainer("change", "#anual_page");
        }
    });

    $("#contacto_btn").on("click", function() {
        $("[data-role=panel]").panel("close");
        $(":mobile-pagecontainer").pagecontainer("change", "#contacto_page");

    });
    $("#actualizaRueda_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Actualizar rueda', // title
                'OK' // buttonName
            );
        } else {

            if (navigator.connection.type === Connection.NONE) {
                alert("Debes tener conexión a Internet");
            } else {

                Rueda.recuperaRuedaServer(rueda_g.getTitulo()).then(
                    function(response) {
                        rueda_g = response;
                        rueda_g.setPropietario(propietario_g);
                        rueda_g.almacenar();

                        renderRueda(Rueda.semanaEnCurso());

                        // Se añade la clase ui-listview para asegurarnos de que elejimos listas ya inicializadas
                        $(".listaCoincidencias ui-listview").each(function() {
                            $(this).listview("refresh");
                        });
                        //alert("Rueda actualizada");

                        navigator.notification.alert(
                            'A la vista semanal', // message
                            function() {
                                $("[data-role=panel]").panel("close");
                                $(":mobile-pagecontainer").pagecontainer("change", "#semana_page");
                            },
                            'Rueda actualizada', // title
                            'OK' // buttonName
                        );


                    },
                    function(error) {
                        console.error("Fallo: ", error);
                    }
                );
            }
        }
    });

    $("#cambiarRueda_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Cambiar de rueda', // title
                'OK' // buttonName
            );
        } else {
            $("[data-role=panel]").panel("close");
            $(":mobile-pagecontainer").pagecontainer("change", "#crearUnir");
        }
    });

    $("#salir_btn").on("click", function() {
        navigator.notification.confirm(
            '¿Salir de la aplicación?',
            function(button) {
                if (button == 2) {
                    navigator.app.exitApp();
                }
            },
            'Cerrar',
            'No,Si'
        );
    });

    $("#dejarRueda_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Todavia no estas en ninguna rueda', // message
                function() {},
                'Dejar la rueda', // title
                'OK' // buttonName
            );
        } else {

            navigator.notification.confirm(
                '¿Salir de la rueda?',
                function(button) {
                    if (button == 2) {
                        if (navigator.connection.type === Connection.NONE) {

                            alert("Debes tener conexión a Internet");

                        } else {
                            rueda_g.borrar();
                            rueda_g = null;
                            propietario_g.setRueda("ninguna");
                            propietario_g.actualizaServer();
                            $("[data-role=panel]").panel("close");
                            $(":mobile-pagecontainer").pagecontainer("change", '#crearUnir');
                        }
                    }
                },
                'Salir',
                'No,Si'
            );
        }
    });

    $("#config_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Configuración', // title
                'OK' // buttonName
            );
        } else {
            $(":mobile-pagecontainer").pagecontainer("change", '#configuracion_page');
        }
    });

    $("#modHorario_btn").on("click", function() {
        if (propietario_g == null || rueda_g == null) {
            navigator.notification.alert(
                'Registrate en una rueda primero', // message
                function() {},
                'Perfil', // title
                'OK' // buttonName
            );
        } else {
            $(":mobile-pagecontainer").pagecontainer("change", '#miPerfil_page');
        }
    });

});

$(document).on("pagebeforeshow", "#configuracion_page", function(event, ui) {

    $("#headerInicio #titulo").html("Opciones");

    switch (vista_g) {
        case "diaria":
            $("#diaria_ra").prop("checked", true).checkboxradio("refresh");
            break;
        case "semanal":
            $("#semanal_ra").prop("checked", true).checkboxradio("refresh");
            break;
        case "home":
            $("#home").prop("checked", true).checkboxradio("refresh");
            break;
    }

    if (botonNavegacion_g) {
        $("#botonNavegacion").prop("checked", true).checkboxradio("refresh");
    }

    $(":input[name='vista']").on('change', function() {
        vista_g = $(this).val();
        localforage.setItem('vista', vista_g);
    });

    $(":input[name='botonNavegacion']").on('change', function() {
        botonNavegacion_g = $(this).is(":checked");
        localforage.setItem('botonNavegacion', botonNavegacion_g);
    });
});

/*--------- PERFIL PAGE -------------------------------------------------*/
$(document).on("pagebeforeshow", "#miPerfil_page", function(event, ui) {

    // Cargamos la cabecera
    $("#headerInicio #titulo").html("Mi Perfil");

    // Cargamos el nombre del usuario que se va a modificar
    $("#nombrePerfil").val(propietario_g.getNombre());

    /* El botón guarda recoge los datos introducidos por el usuario y crea un objeto profesor
     * para almacenarlos. Una vez guardados se lanza la pagina de confirmación.
     */
    $("#pLunes_e").val(propietario_g.getEntrada(0));
    $("#pLunes_e").slider("refresh");
    $("#pLunes_s").val(propietario_g.getSalida(0));
    $("#pLunes_s").slider("refresh");
    $("#pMartes_e").val(propietario_g.getEntrada(1));
    $("#pMartes_e").slider("refresh");
    $("#pMartes_s").val(propietario_g.getSalida(1));
    $("#pMartes_s").slider("refresh");
    $("#pMiercoles_e").val(propietario_g.getEntrada(2));
    $("#pMiercoles_e").slider("refresh");
    $("#pMiercoles_s").val(propietario_g.getSalida(2));
    $("#pMiercoles_s").slider("refresh");
    $("#pJueves_e").val(propietario_g.getEntrada(3));
    $("#pJueves_e").slider("refresh");
    $("#pJueves_s").val(propietario_g.getSalida(3));
    $("#pJueves_s").slider("refresh");
    $("#pViernes_e").val(propietario_g.getEntrada(4));
    $("#pViernes_e").slider("refresh");
    $("#pViernes_s").val(propietario_g.getSalida(4));
    $("#pViernes_s").slider("refresh");

    $("#guardarPerfil_btn").on("click", function() {

        idBD = propietario_g.getIDBD();
        rueda = propietario_g.getRueda();

        propietario_g = new Profesor($("#nombrePerfil").val(), numPropietario_g, $("#pLunes_e").val(), $("#pLunes_s").val(),
            $("#pMartes_e").val(), $("#pMartes_s").val(), $("#pMiercoles_e").val(), $("#pMiercoles_s").val(), $("#pJueves_e").val(),
            $("#pJueves_s").val(), $("#pViernes_e").val(), $("#pViernes_s").val(), rueda, idBD
        );

        $(":mobile-pagecontainer").pagecontainer("change", '#confirmacionPerfil_page');

    });

});

/*--------- CONFIRMACION REGISTRO PAGE -------------------------------------------------*/
/* Muestra un feedback de los datos introducidos por el usuario.
 */
$(document).on("pagebeforeshow", "#confirmacionPerfil_page", function(event, ui) {

    $("#headerInicio #titulo").html("Mi perfil: horario");

    // Mostrar el nombre registrado
    $("#nombreRegistrado").html("<p>" + propietario_g.getNombre() + "</p><p>vas a registrar este horario</p>");

    $("#horarioPerfil").html(
        Handlebars.templates.cabeceraRegistro([
            ['a', 'L'],
            ['b', 'M'],
            ['c', 'X'],
            ['d', 'J'],
            ['e', 'V']
        ]) +
        Handlebars.templates.horarioPerfil([1, 2, 3, 4, 5, 6])
    );

    // Mostrar el horario registrado
    for (dia = 0; dia < 5; dia++) {

        var inicio = parseInt(propietario_g.getEntrada(dia));
        var fin = parseInt(propietario_g.getSalida(dia));

        for (hora = 1; hora < 7; hora++) {
            if (inicio > hora || fin < hora || inicio == fin) {
                $("#p" + Rueda.DIA_LETRAS[dia] + "-" + hora).css("background", "#444444");
            } else {
                $("#p" + Rueda.DIA_LETRAS[dia] + "-" + hora).css("background", "#ffffff");
            }
        }
    }

    $("#dePerfilARueda_btn").on("click", function() {

        if (navigator.connection.type === Connection.NONE) {

            alert("Debes tener conexión a Internet");
        } else {
            propietario_g.actualizaServer();
            rueda_g.actualizaMiembro(propietario_g);
            rueda_g.setPropietario(propietario_g);
            renderRueda(Rueda.semanaEnCurso());
            irAHoy();
        }
    });

});